SystemOrganization addCategory: #ScriptBook!

SMPackageRelease subclass: #SBScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ScriptBook'!

!SBScript methodsFor: 'as yet unclassified' stamp: 'chc 4/15/2019 09:34'!
fullDescription
	"Return a full textual description of the package release."

	| s |
	s := TextStream on: (Text new: 400).
"	self describe: self package name withBoldLabel: 'Package Name: ' on: s."
	name isEmptyOrNil ifFalse:
		[self describe: self name withBoldLabel: 'Release Name: ' on: s].
	summary isEmptyOrNil ifFalse:
		[self describe: self summary withBoldLabel: 'Release Summary: ' on: s].

"	self 
		describe: self version
		withBoldLabel: 'Version: '
		on: s."

	self note isEmptyOrNil 
		ifFalse: 
			[ s withAttribute: (TextIndent tabs: 1) do: [s nextPutAll: self note withSqueakLineEndings].
			s cr].

	categories isEmptyOrNil 
		ifFalse: 
			[s
				cr;
				withAttribute: TextEmphasis bold do: [s nextPutAll: 'Categories: '];
				cr.
			(self categories sorted: [:a :b | a path < b path])
				do: [:c | 
					s
						tab;
						withAttribute: TextEmphasis italic
							do: 
								[c parentsDo: 
										[:p | 
										s
											nextPutAll: p name;
											nextPutAll: '/'].
								s nextPutAll: c name];
						nextPutAll: ' - ' , c summary;
						cr].
			s cr].

	"created ifNotNil: [
		s
			withAttribute: TextEmphasis bold do: [ s nextPutAll: 'Created: ' ];
			print: self created;
			cr].
	updated ifNotNil: [
		s
			withAttribute: TextEmphasis bold do: [ s nextPutAll: 'Modified: ' ];
			print: self updated;
			cr]."
	publisher ifNotNil: [
		s
			withAttribute: TextEmphasis bold
			do: [s nextPutAll: 'Publisher: '].
		s
			withAttribute: (PluggableTextAttribute
					evalBlock: [self userInterface
									sendMailTo: self publisher email
									regardingPackageRelease: self])
			do: [s nextPutAll: self publisher nameAndEmail];	
			cr].

	url isEmptyOrNil 
		ifFalse: 
			[s
				withAttribute: TextEmphasis bold do: [s nextPutAll: 'Homepage:'];
				tab;
				withAttribute: (TextURL new url: url) do: [s nextPutAll: url];
				cr].
	self downloadUrl isEmptyOrNil 
		ifFalse: 
			[s
				withAttribute: TextEmphasis bold do: [s nextPutAll: 'Download:'];
				tab;
				print: self downloadUrl;
				cr].
	^s contents.

! !

SMSqueakMap subclass: #SBModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ScriptBook'!

!SBModel class methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2019 11:21'!
new
	"Answer a new initialized instance of the receiver (which is a class) with no indexable variables. Fail if the class is indexable."

	^ self basicNew initialize
! !

!SBModel methodsFor: 'as yet unclassified' stamp: 'chc 4/16/2019 08:40'!
objects
	^objects! !

!SBModel methodsFor: 'as yet unclassified' stamp: 'chc 4/16/2019 08:40'!
objects: anObject
	objects := anObject! !

SMLoaderPlus subclass: #ScriptBook
	instanceVariableNames: 'sm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ScriptBook'!

!ScriptBook commentStamp: 'chc 4/7/2019 10:36' prior: 0!
ScriptBook open!

!ScriptBook class methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2019 11:36'!
new
	"Answer a new initialized instance of the receiver (which is a class) with no indexable variables. Fail if the class is indexable."

	^ self basicNew initialize
! !

!ScriptBook methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2019 11:33'!
addScript: aScript andName: aName
	|package release |
	package := SMPackage newIn: map. 
	package name: aName.
	release := SBScript newFromRelease: nil package: package. 
	release downloadUrl: aScript.	
	package addRelease: release. 
	map addObject: package.
	! !

!ScriptBook methodsFor: 'as yet unclassified' stamp: 'chc 4/15/2019 09:36'!
defaultLabel
	^ 'Script Book'! !

!ScriptBook methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2019 11:41'!
initialize
	map := SBModel new.
	map objects: Dictionary new. 
	self scripts keysAndValuesDo: [:key :value| 
		self addScript: key andName: value ].
	(Smalltalk at: #ToolBuilder) open: self 
	! !

!ScriptBook methodsFor: 'as yet unclassified' stamp: 'chc 4/16/2019 08:41'!
map
	^map! !

!ScriptBook methodsFor: 'as yet unclassified' stamp: 'chc 4/16/2019 08:42'!
map: anObject
	map := anObject! !

!ScriptBook methodsFor: 'as yet unclassified' stamp: 'chc 4/15/2019 09:53'!
packageList
	| list |
	list := map packages.
	^ list! !

!ScriptBook methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2019 11:39'!
scripts

	^{
	'Installer ensureRecentMetacello.
(Smalltalk classNamed: #Metacello) new
   repository: ''github://j4yk/tonel:squeak'';
   baseline: ''Tonel'';
   load'->'Tonel'
.
	'(Installer ss project: ''OSProcess'') install: ''OSProcess-dtl.110'''->'OSProcess'
.
	 '(FileDirectory default  directoryExists: ''ScratchSkin'') ifFalse:[ UIManager default inform: ''Before loading this package you must download\ http://download.scratch.mit.edu/source-code/ScratchSkin1.4.zip\ and unzip it to create the ScratchSkin directory\ with all the required media files.'' withCRs.
	^0].
(Installer repository: ''http://www.squeaksource.com/NuScratch'' ) install: ''NuScratch-tpr.381.mcz'''->'NuScratch'
.
	'SMSqueakMap default loadUpdates.

"AST preqrequisite."
(Smalltalk hasClassNamed: #RBParser) 
	ifFalse: [ SMSqueakMap default installPackageNamed: ''AST'' version: ''5.2'' ].

"Tools only."
#(''Refactoring-Core-ul.162'' ''Refactoring-Changes-eem.22'' ''Refactoring-Environment-eem.11'' ''Refactoring-Critics-ul.20'' ''Refactoring-Spelling-pmm.28'' ) do:
	[ : each |
	(Installer repository: ''http://www.squeaksource.com/rb'') install: each ].
#(''RefactoringTools-eem.7'')
do:
	[ : each |
	(Installer repository: ''http://ss3.gemtalksystems.com/ss/RefactoringToolsForSqueak'') install: each ].

"Tests."
#(''Refactoring-Tests-Core-lr.56'' ''Refactoring-Tests-Changes-lr.16'' ''Refactoring-Tests-Environment-eem.5'' ''Refactoring-Tests-Critics-lr.4'' ''Refactoring-Tests-Spelling-lr.9'' ''Refactoring-Squeak-Platform-cwp.2'' ) do:
	[ : each |
	(Installer repository: ''http://www.squeaksource.com/rb'') install: each ]'->'Refactoring Tools'

	} as: Dictionary! !
